--[[
	Skip's main lua
		Made by Bloops and SMS Alfredo
		Made for DrStephen
	Enjoy!~
]]--

freeslot(
	"S_PLAY_SKIPDIVE",
	"SPR2_DIVE",
	"S_PLAY_SKIPCANCEL",
	"S_PLAY_SKIPALTDIVE",
	"S_PLAY_SKIPCROUCH",
	"S_PLAY_SKIPDOUBLEJUMP",
	"S_PLAY_SKIPSLIDE",
	"S_PLAY_SKIPBONK",
	"S_PLAY_SKIPJUMP",
	"S_PLAY_SKIPSMUG",
	
	"SPR_SKRP",
	"MT_SKIPMETALSCRAP",
	"S_SKIPMETALSCRAP",
	
	"SPR_FLGH",
	"MT_SKIPFLASHLIGHT",
	"S_SKIPFLASHLIGHT",
	"sfx_skpflg",
	
	"MT_SKIPRAYCAST",
	
	"sfx_skpdbl",
	"sfx_skpms1",
	"sfx_skpms2",
	"sfx_skpchg",
	"sfx_sfstep"
)

mobjinfo[MT_SKIPMETALSCRAP] = {
	doomednum = -1,
	spawnstate = S_SKIPMETALSCRAP,
	deathstate = S_DUST1,
	xdeathstate = S_DUST1,
	spawnhealth = 1000,
	speed = 32*FRACUNIT,
	radius = 16*FRACUNIT,
	height = 16*FRACUNIT,
	flags = MF_SCENERY|MF_SPECIAL|MF_SLIDEME
}

states[S_SKIPMETALSCRAP] = {SPR_SKRP, A, TICRATE*10, nil, 0, 0, S_NULL}

mobjinfo[MT_SKIPFLASHLIGHT] = {
	doomednum = -1,
	spawnstate = S_SKIPFLASHLIGHT,
	spawnhealth = 1000,
	speed = 32*FRACUNIT,
	radius = FRACUNIT,
	height = FRACUNIT,
	flags = MF_SCENERY|MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOCLIPTHING
}

states[S_SKIPFLASHLIGHT] = {SPR_FLGH, FF_FULLBRIGHT|TR_TRANS70|A, 1, A_CapeChase,
24*FRACUNIT, 16*FRACUNIT, S_SKIPFLASHLIGHT}

sfxinfo[sfx_skpflg].caption = "Flashlight"

mobjinfo[MT_SKIPRAYCAST] = {
	doomednum = -1,
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	speed = 64*FRACUNIT,
	radius = 64*FRACUNIT,
	height = FRACUNIT,
	flags = MF_SCENERY|MF_NOBLOCKMAP|MF_NOCLIPTHING
}

states[S_PLAY_SKIPDIVE] = {SPR_PLAY, SPR2_DIVE, 4, nil, 0, 0, S_PLAY_SKIPDIVE}
states[S_PLAY_SKIPCROUCH] = {SPR_PLAY, SPR2_LAND, 4, nil, 0, 0, S_PLAY_SKIPCROUCH}
states[S_PLAY_SKIPCANCEL] = {SPR_PLAY, SPR2_ROLL|FF_ANIMATE, 8, nil, 8, 2, S_PLAY_SPRING}
states[S_PLAY_SKIPALTDIVE] = {SPR_PLAY, SPR2_ROLL|FF_ANIMATE, 8, nil, 8, 2, S_PLAY_SKIPDIVE}
states[S_PLAY_SKIPDOUBLEJUMP] = {SPR_PLAY, SPR2_ROLL|FF_ANIMATE, 12, nil, 8, 3, S_PLAY_SPRING}
states[S_PLAY_SKIPSLIDE] = {SPR_PLAY, SPR2_SPIN, 4, nil, 0, 0, S_PLAY_SKIPSLIDE}
states[S_PLAY_SKIPBONK] = {SPR_PLAY, SPR2_PAIN, 4, nil, 0, 0, S_PLAY_SKIPBONK}
states[S_PLAY_SKIPJUMP] = {SPR_PLAY, SPR2_LAND, 4, nil, 0, 0, S_PLAY_SPRING}
states[S_PLAY_SKIPSMUG] = {SPR_PLAY, SPR2_CLMB, 5, nil, 0, 0, S_PLAY_SKIPSMUG}

sfxinfo[sfx_skpdbl].caption = "Double Jumping"
sfxinfo[sfx_skpms1].caption = "Collect Small scrap metal"
sfxinfo[sfx_skpms1].flags = SF_TOTALLYSINGLE
sfxinfo[sfx_skpms2].caption = "Collect Big scrap metal"
sfxinfo[sfx_skpms2].flags = SF_TOTALLYSINGLE
sfxinfo[sfx_skpchg].caption = "Charging"
sfxinfo[sfx_sfstep].caption = "Step"

//Color table for the different badniks
//Default color is Cloudy
local skipbadnikcolor = {}
skipbadnikcolor[MT_BLUECRAWLA] = SKINCOLOR_AZURE
skipbadnikcolor[MT_REDCRAWLA] = SKINCOLOR_RED
skipbadnikcolor[MT_GFZFISH] = SKINCOLOR_BLUE
skipbadnikcolor[MT_GOLDBUZZ] = SKINCOLOR_GOLD
skipbadnikcolor[MT_REDBUZZ] = SKINCOLOR_RED
skipbadnikcolor[MT_JETTBOMBER] = SKINCOLOR_APPLE
skipbadnikcolor[MT_JETTGUNNER] = SKINCOLOR_GOLD
skipbadnikcolor[MT_CRAWLACOMMANDER] = SKINCOLOR_BLUE
skipbadnikcolor[MT_DETON] = SKINCOLOR_RED
//MT_SKIM
skipbadnikcolor[MT_TURRET] = SKINCOLOR_DUSK
skipbadnikcolor[MT_POPUPTURRET] = SKINCOLOR_GREY
skipbadnikcolor[MT_SPINCUSHION] = SKINCOLOR_CERULEAN
skipbadnikcolor[MT_CRUSHSTACEAN] = SKINCOLOR_RED
skipbadnikcolor[MT_BANPYURA] = SKINCOLOR_AQUA
skipbadnikcolor[MT_JETJAW] = SKINCOLOR_ORANGE
skipbadnikcolor[MT_SNAILER] = SKINCOLOR_RED
skipbadnikcolor[MT_VULTURE] = SKINCOLOR_RED
skipbadnikcolor[MT_POINTY] = SKINCOLOR_CERULEAN
skipbadnikcolor[MT_ROBOHOOD] = SKINCOLOR_GREEN
skipbadnikcolor[MT_FACESTABBER] = SKINCOLOR_RED
skipbadnikcolor[MT_EGGGUARD] = SKINCOLOR_LILAC
skipbadnikcolor[MT_GSNAPPER] = SKINCOLOR_GREEN
//MT_MINUS
skipbadnikcolor[MT_SPRINGSHELL] = SKINCOLOR_BLUEBELL
skipbadnikcolor[MT_YELLOWSHELL] = SKINCOLOR_ORANGE
skipbadnikcolor[MT_UNIDUS] = SKINCOLOR_JET
//MT_CANARIVORE
skipbadnikcolor[MT_PYREFLY] = SKINCOLOR_CRIMSON
skipbadnikcolor[MT_PTERABYTE] = SKINCOLOR_LILAC
skipbadnikcolor[MT_DRAGONBOMBER] = SKINCOLOR_JET
skipbadnikcolor[MT_PENGUINATOR] = SKINCOLOR_BLUE
skipbadnikcolor[MT_POPHAT] = SKINCOLOR_AETHER
skipbadnikcolor[MT_HIVEELEMENTAL] = SKINCOLOR_YELLOW
skipbadnikcolor[MT_BUMBLEBORE] = SKINCOLOR_YELLOW
skipbadnikcolor[MT_BUGGLE] = SKINCOLOR_AZURE
skipbadnikcolor[MT_CACOLANTERN] = SKINCOLOR_ORANGE
skipbadnikcolor[MT_SPINBOBERT] = SKINCOLOR_AETHER
skipbadnikcolor[MT_HANGSTER] = SKINCOLOR_PURPLE
skipbadnikcolor[MT_METALSONIC_BATTLE] = SKINCOLOR_COBALT
skipbadnikcolor[MT_BLACKEGGMAN] = SKINCOLOR_BLACK
skipbadnikcolor[MT_CYBRAKDEMON] = SKINCOLOR_BLACK

//List of monitors
//Switch around the constants to change the order and cost
local skipcraftlist = {
	MT_SNEAKERS_BOX,
	MT_BUBBLEWRAP_BOX,
	MT_ATTRACT_BOX,
	MT_FORCE_BOX,
	MT_ARMAGEDDON_BOX,
	MT_ELEMENTAL_BOX,
	MT_INVULN_BOX,
	MT_FLAMEAURA_BOX,
	MT_WHIRLWIND_BOX,
	MT_THUNDERCOIN_BOX,
}
skipcraftlist[0] = MT_PITY_BOX //This is dumb

//List of gold monitors
//Match the constants here with the ones above
local skipgoldcraftlist = {
	MT_SNEAKERS_GOLDBOX,
	MT_BUBBLEWRAP_GOLDBOX,
	MT_ATTRACT_GOLDBOX,
	MT_FORCE_GOLDBOX,
	MT_ARMAGEDDON_GOLDBOX,
	MT_ELEMENTAL_GOLDBOX,
	MT_INVULN_GOLDBOX,
	MT_FLAMEAURA_GOLDBOX,
	MT_WHIRLWIND_GOLDBOX,
	MT_THUNDERCOIN_GOLDBOX,
}
skipgoldcraftlist[0] = MT_PITY_GOLDBOX //This is still dumb

//Cost for each monitor
local skipcostlist = {
	22,
	30,
	45,
	52,
	60,
	68,
	75,
	75,
	90,
	95,
}
skipcostlist[0] = 18 //This continues to be really dumb

//List of Passive Abilities
local skippassivelist = {
	"Increased Speed",
	"Infinite Air",
	"Ring Attraction",
	"Two Hit Points",
	"Explodes on Contact",
	"Fire/Water Protection",
	"Invincible",
	"Fire Protection",
	nil,
	"Ring Attraction",
}

//List of Active Abilities
local skipactivelist = {
	nil,
	"Bounce Dive",
	"Homing Dive",
	"Wall Jump Dive",
	"Charge Dive",
	"Meteor Dive",
	nil,
	"Burst Dive",
	"High Dive",
	"Wire Dive",
}

//Additional Scrap for certain enemies
local skipbadnikscrap = {}
skipbadnikscrap[MT_JETTBOMBER] = 4
skipbadnikscrap[MT_JETTGUNNER] = 4
skipbadnikscrap[MT_CRUSHSTACEAN] = 6
skipbadnikscrap[MT_BANPYURA] = 6
skipbadnikscrap[MT_POINTY] = 6
skipbadnikscrap[MT_EGGGUARD] = 5
skipbadnikscrap[MT_FACESTABBER] = 7
skipbadnikscrap[MT_GSNAPPER] = 6
skipbadnikscrap[MT_MINUS] = 4
skipbadnikscrap[MT_UNIDUS] = 5
skipbadnikscrap[MT_PYREFLY] = 6
skipbadnikscrap[MT_DRAGONBOMBER] = 8
skipbadnikscrap[MT_TURRET] = 4
skipbadnikscrap[MT_CACOLANTERN] = 6
skipbadnikscrap[MT_SPINBOBERT] = 4

//Total number of monitors (minus one of course)
local skiptotalcraft = 10

//Command to enable infinite scrap
CV_RegisterVar({
	name = "infinitescrap",
	defaultvalue = "Off",
	flags = CV_NETVAR|CV_SHOWMODIF|CV_CHEAT,
	PossibleValue = CV_OnOff
})

//Skip's HUD and Menu
//along with a very dangerous chasecam variable
local verydangerouschasecamvariable = true
hud.add(function(v, player, cam)
	verydangerouschasecamvariable = cam.chase
	if not (player.mo and player.mo.valid and player.mo.skin == "skip"
	and player.skipscrap != nil and not G_IsSpecialStage()) return end
	
	//Scrap HUD
	
	//Metal Graphic
	v.draw(24,168,v.getSpritePatch(SPR_SKRP),
	V_HUDTRANS|V_PERPLAYER|V_SNAPTOBOTTOM|V_SNAPTOLEFT, v.getColormap(nil, SKINCOLOR_CLOUDY))
	
	//X (changes position based on the number of digits)
	if player.skipscrap >= 100000
		//
	elseif player.skipscrap >= 10000
		v.draw(28,168,v.cachePatch("STLIVEX"),
		V_HUDTRANS|V_PERPLAYER|V_SNAPTOBOTTOM|V_SNAPTOLEFT)
	elseif player.skipscrap >= 1000
		v.draw(36,168,v.cachePatch("STLIVEX"),
		V_HUDTRANS|V_PERPLAYER|V_SNAPTOBOTTOM|V_SNAPTOLEFT)
	else
		v.draw(38,168,v.cachePatch("STLIVEX"),
		V_HUDTRANS|V_PERPLAYER|V_SNAPTOBOTTOM|V_SNAPTOLEFT)
	end
	
	//The number itself
	if CV_FindVar("infinitescrap").value
		v.drawString(74,166,"",
		V_HUDTRANS|V_PERPLAYER|V_SNAPTOBOTTOM|V_SNAPTOLEFT, "right")
	else
		v.drawString(74,166,player.skipscrap,
		V_HUDTRANS|V_PERPLAYER|V_SNAPTOBOTTOM|V_SNAPTOLEFT, "right")
	end
	
	//Crafting Menu
	if player.skipyoffset
		local stupid = "SKIPNORM"
		if player.mo.skipgold then stupid = "SKIPGOLD" end
		v.drawScaled(110*FRACUNIT, (200-(player.skipyoffset*5))*FRACUNIT, FRACUNIT/2,
		v.cachePatch(stupid),V_HUDTRANS|V_SNAPTOBOTTOM|V_PERPLAYER)
		
		if (player.lefttapping or player.righttapping) and not player.forwardtapping
			v.draw(160,(227-(player.skipyoffset*5)),
			v.cachePatch("SKIPSTAT"), V_HUDTRANS|V_SNAPTOBOTTOM|V_PERPLAYER)
			
			v.drawScaled(133*FRACUNIT, (223-(player.skipyoffset*5))*FRACUNIT, FRACUNIT/2,
			v.cachePatch("SKIPSTAT"), V_HUDTRANS|V_SNAPTOBOTTOM|V_PERPLAYER)
		
			v.drawScaled(121*FRACUNIT,(223-(player.skipyoffset*5))*FRACUNIT, FRACUNIT/2,
			v.cachePatch("SKIPSTAT"),V_HUDTRANS|V_SNAPTOBOTTOM|V_PERPLAYER)
		
			v.drawScaled(187*FRACUNIT,(223-(player.skipyoffset*5))*FRACUNIT, FRACUNIT/2,
			v.cachePatch("SKIPSTAT"),V_HUDTRANS|V_SNAPTOBOTTOM|V_PERPLAYER)

			v.drawScaled(199*FRACUNIT,(223-(player.skipyoffset*5))*FRACUNIT, FRACUNIT/2,
			v.cachePatch("SKIPSTAT"),V_HUDTRANS|V_SNAPTOBOTTOM|V_PERPLAYER)
		else
			v.draw(160,(227-(player.skipyoffset*5)),
			v.getSpritePatch(states[mobjinfo[skipcraftlist[player.mo.skipselection]].spawnstate].sprite, 2),
			V_HUDTRANS|V_SNAPTOBOTTOM|V_PERPLAYER)
		
			stupid = player.mo.skipselection-1
			if stupid < 0 then stupid = $+skiptotalcraft+1 end
			v.drawScaled(133*FRACUNIT, (223-(player.skipyoffset*5))*FRACUNIT, FRACUNIT/2,
			v.getSpritePatch(states[mobjinfo[skipcraftlist[stupid]].spawnstate].sprite, 2),
			V_HUDTRANS|V_SNAPTOBOTTOM|V_PERPLAYER)
		
			stupid = player.mo.skipselection-2
			if stupid < 0 then stupid = $+skiptotalcraft+1 end
			v.drawScaled(121*FRACUNIT, (223-(player.skipyoffset*5))*FRACUNIT, FRACUNIT/2,
			v.getSpritePatch(states[mobjinfo[skipcraftlist[stupid]].spawnstate].sprite, 2),
			V_HUDTRANS|V_SNAPTOBOTTOM|V_PERPLAYER)
		
			stupid = player.mo.skipselection+1
			if stupid > skiptotalcraft then stupid = $-(skiptotalcraft+1) end
			v.drawScaled(187*FRACUNIT, (223-(player.skipyoffset*5))*FRACUNIT, FRACUNIT/2,
			v.getSpritePatch(states[mobjinfo[skipcraftlist[stupid]].spawnstate].sprite, 2),
			V_HUDTRANS|V_SNAPTOBOTTOM|V_PERPLAYER)
		
			stupid = player.mo.skipselection+2
			if stupid > skiptotalcraft then stupid = $-(skiptotalcraft+1) end
			v.drawScaled(199*FRACUNIT, (223-(player.skipyoffset*5))*FRACUNIT, FRACUNIT/2,
			v.getSpritePatch(states[mobjinfo[skipcraftlist[stupid]].spawnstate].sprite, 2),
			V_HUDTRANS|V_SNAPTOBOTTOM|V_PERPLAYER)
		end
		
		stupid = skipcostlist[player.mo.skipselection] //Cost
		if player.mo.skipgold then stupid = $*2 end //Gold Multiplier
		if All7Emeralds(emeralds)
			stupid = $*40/54 //Emerald Discount
			v.drawScaled(174*FRACUNIT,(226-(player.skipyoffset*5))*FRACUNIT, FRACUNIT/2,
			v.cachePatch("SKIPEMER"), V_HUDTRANS|V_SNAPTOBOTTOM|V_PERPLAYER)
		end
		v.drawString(160, 248-(player.skipyoffset*5), "Cost: "..stupid,
		V_HUDTRANS|V_SNAPTOBOTTOM|V_PERPLAYER, "thin-center")
		
		stupid = skippassivelist[player.mo.skipselection]
		if stupid == nil then stupid = "None" end
		v.drawString(160, 255-(player.skipyoffset*5), "Passive: "..stupid,
		V_HUDTRANS|V_SNAPTOBOTTOM|V_PERPLAYER, "thin-center")
		
		if skipcraftlist[player.mo.skipselection] == MT_SNEAKERS_BOX
		or skipcraftlist[player.mo.skipselection] == MT_INVULN_BOX
			v.drawString(160, 262-(player.skipyoffset*5), "Temporarily",
			V_HUDTRANS|V_SNAPTOBOTTOM|V_PERPLAYER, "thin-center")
		else
			stupid = skipactivelist[player.mo.skipselection]
			if stupid == nil then stupid = "None" end
			v.drawString(160, 262-(player.skipyoffset*5), "Active: "..stupid,
			V_HUDTRANS|V_SNAPTOBOTTOM|V_PERPLAYER, "thin-center")
		end
	end
end)

//Reset Skip's variables
local function resetskip(player)
	if player.mo and player.mo.valid
		if player.skipsmug
			if player.mo.state == S_PLAY_SKIPSMUG
				player.mo.state = S_PLAY_STND
			end
			P_RestoreMusic(player)
			player.skipsmug = false
		end
		if player.mo.skipdove
			player.mo.skipdove = false
			player.pflags = $&~PF_DRILLING
		end
		player.mo.skipsteam = false
		player.mo.skipdivehit = false
		player.mo.skipperfectwindow = 0
		player.mo.skipcrouching = false
		player.mo.skipwiredive = 0
		player.mo.skipwiredivedir = player.drawangle
		player.mo.skipchargedive = 0
		player.mo.skipmenu = false
		player.mo.skipcrouchdir = 0
		if player.height == skins[player.mo.skin].spinheight
			player.height = skins[player.mo.skin].height
		end
		if player.normalspeed == 0
			player.normalspeed = skins[player.mo.skin].normalspeed
		end
	end
end

//Set the dive momentum
local function skipdive(player)
	if player.mo and player.mo.valid and player.mo.skin == "skip"
		local returnvalue = player.speed
		if (player.powers[pw_shield] & SH_NOSTACK) == SH_FLAMEAURA
		or ((player.powers[pw_shield] & SH_NOSTACK) == SH_ELEMENTAL
		and not P_IsObjectOnGround(player.mo))
			player.pflags = $|PF_SHIELDABILITY
			S_StartSound(player.mo, sfx_s3k43)
			returnvalue = 60*player.mo.scale
			if (player.powers[pw_shield] & SH_NOSTACK) == SH_ELEMENTAL
				returnvalue = $-(10*player.mo.scale)
			end
		elseif player.speed >= 40*player.mo.scale
			returnvalue = player.speed + FixedMul((player.actionspd/4), player.mo.scale)
		elseif player.speed > 5*player.mo.scale or player.speed == 5*player.mo.scale
			returnvalue = player.speed + FixedMul((player.actionspd/3), player.mo.scale)
		else
			returnvalue = FixedMul(player.actionspd/(3/2), player.mo.scale)
		end
		
		//Speed Cap
		if player.mysticsuper
			if returnvalue > player.mo.scale*140 --Increased speed cap for Mystic Super!
			returnvalue = player.mo.scale*140
			end
		elseif (player.powers[pw_shield] & SH_NOSTACK) == SH_BUBBLEWRAP
		and returnvalue > player.mo.scale*60
			returnvalue = player.mo.scale*60
		elseif returnvalue > player.mo.scale*80
			returnvalue = player.mo.scale*80
		end
		
		//Increase the speed when you're on the ground to circumvent speed loss
		if P_IsObjectOnGround(player.mo)
			return returnvalue + (player.mo.scale*5)
		else
			return returnvalue
		end
	end
end

//Get the player's input angle
local function inputangle(player)
	if P_GetPlayerControlDirection(player) == 0
	or player.mo.flags2 & MF2_TWOD or twodlevel
		return player.drawangle
	else 
		return player.cmd.angleturn<<16 + R_PointToAngle2(0, 0, player.cmd.forwardmove*FRACUNIT, -player.cmd.sidemove*FRACUNIT)
	end
end

//Spawn dust
local function skipdust(player)
	if player.mo and player.mo.valid and player.mo.skin == "skip"
		for i = 1, 16 --taken from werehog with permission lol
			local dust = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z + (player.mo.eflags & MFE_VERTICALFLIP and 4*player.mo.scale or 0), player.mo.eflags & (MFE_UNDERWATER | MFE_TOUCHWATER) and MT_MEDIUMBUBBLE or MT_PARTICLE)
			dust.fuse = TICRATE/4
			dust.scale = player.mo.scale
			dust.destscale = player.mo.scale/8
			dust.eflags = player.mo.eflags & MFE_VERTICALFLIP
			P_InstaThrust(dust, i*ANGLE_22h, 6*player.mo.scale)
			dust.momz = -2*P_MobjFlip(player.mo)*player.mo.scale
			dust.frame = $|TR_TRANS60
		end
	end
end

//Spawns objects in a circle
local function skipcircle(mobj, mobjtype, ns, vertical, vertangle)
	local i = 0	while i < 8
		local fa = (i*(ANGLE_180/4))
		local mo = P_SpawnMobj(mobj.x, mobj.y, mobj.z+(mobj.height/2), mobjtype)
		if mo and mo.valid
			if mobjtype == MT_DUST
				if mobj.eflags & (MFE_TOUCHWATER|MFE_UNDERWATER)
					mo.state = S_SMALLBUBBLE
				elseif mobj.player and
				((mobj.player.powers[pw_shield] & SH_NOSTACK) == SH_ELEMENTAL
				or (mobj.player.powers[pw_shield] & SH_NOSTACK) == SH_FLAMEAURA)
					mo.state = S_SPINDUST_FIRE1
				else
					mo.state = S_SPINDUST1
				end
			end
			if vertical
				mo.momz = FixedMul(sin(fa),ns)/2
				P_InstaThrust(mo, vertangle+ANGLE_90,
				FixedMul(cos(fa),ns)/2)
			else
				mo.momx = FixedMul(sin(fa),ns)/2
				mo.momy = FixedMul(cos(fa),ns)/2
			end
		end
		i = $+1
	end
end

//Spawn scrap metal
local function skipmetalscrap(target, source)
	if not (target and target.valid) return end
	local scrap = P_SpawnMobjFromMobj(target,0,0,0,MT_SKIPMETALSCRAP)
	if scrap and scrap.valid
		scrap.shadowscale = FRACUNIT/2
		scrap.reactiontime = scrap.scale
			
		//Change the color
		if target.color
			scrap.color = target.color
		elseif skipbadnikcolor[target.type]
			scrap.color = skipbadnikcolor[target.type]
		else
			scrap.color = SKINCOLOR_CLOUDY
		end
			
		scrap.cusval = scrap.color
			
		//Do the movement
		P_SetObjectMomZ(scrap, FRACUNIT*10, true)
		P_InstaThrust(scrap, FixedAngle(360*P_RandomFixed()), 10*P_RandomFixed())
		scrap.rollangle = FixedAngle(360*P_RandomFixed())
			
		//Big scraps
		if (P_RandomChance(FRACUNIT/3) or target.player) and not (target.player
		and target.player.skipscrap and target.player.skipscrap < 2)
			scrap.threshold = 2
			if P_RandomChance(FRACUNIT/3)
				scrap.scale = $*3/2
				scrap.shadowscale = $*2/3
				scrap.frame = 0
			elseif P_RandomChance(FRACUNIT/2)
				if target.type == MT_BLUECRAWLA or target.type == MT_REDCRAWLA
					scrap.frame = 7
				elseif target.type == MT_CRUSHSTACEAN or target.type == MT_BANPYURA
					scrap.frame = 8
				elseif target.type == MT_GSNAPPER or target.type == MT_SPINCUSHION
					scrap.frame = 9
				end
			else
				scrap.height = $*2
				scrap.radius = $*2
				scrap.shadowscale = $/2
				scrap.frame = P_RandomRange(5,6)
			end
			
		//Small scraps
		else
			scrap.threshold = 1
			scrap.scale = $*3/2
			scrap.shadowscale = $/2
			scrap.frame = P_RandomRange(1,4)
		end
		scrap.frame = $|FF_FULLBRIGHT
			
		if target.player and target.player.skipscrap
			target.player.skipscrap = max($-scrap.threshold,0)
			scrap.skiplessmagnetic = true
			if target.health
				P_InstaThrust(scrap, FixedAngle(360*P_RandomFixed()), 15*scrap.reactiontime)
			end
		end
		
		//If we're provided a target to home in on, set it
		if source and source.valid and source.player and source.skin == "skip"
			scrap.target = source
		end
	end
end

//Spawn scrap metal when an enemy gets hurt
addHook("MobjDamage", function(target, inflictor, source, damage, damagetype)
	if target and target.valid and (target.flags&MF_ENEMY or target.flags&MF_BOSS)
	and target.type != MT_GOOMBA and target.type != MT_BLUEGOOMBA //and target.type != MT_FANG
	and source and source.valid and source.player
	
		//If Skip didn't kill an enemy, check if any other Skip players exist
		//If not, don't spawn the scrap
		if source.skin != "skip"
			local skip = false
			for player in players.iterate
				if player.mo and player.mo.valid and player.mo.skin == "skip"
				and not player.bot
					skip = true
				end
			end
			if not skip return end
		end
		
		//Get back your jump abilities when you hit an enemy with the homing dive
		if source.skin == "skip" and source.player.pflags & PF_SHIELDABILITY
		and (source.player.powers[pw_shield] & SH_NOSTACK) == SH_ATTRACT
		and source.skipdove and not P_IsObjectOnGround(source)
			source.player.pflags = $|PF_JUMPED&~PF_THOKKED&~PF_SHIELDABILITY&~PF_DRILLING
			source.skipdove = false
			source.state = S_PLAY_SKIPCANCEL
			P_SetObjectMomZ(source, 10*FRACUNIT, false)
		end
	
		local amount = 2
		if target.health <= 1
			amount = max(min(target.info.spawnhealth*2, 8),1)
			if skipbadnikscrap[target.type]
				amount = $+skipbadnikscrap[target.type]
			end
		end
		for i = 1, amount
			skipmetalscrap(target, source)
		end
	end
end)

//Ring Boxes give you scrap
addHook("MobjDeath", function(target, inflictor, source, damage, damagetype)
	if target and target.valid
	and source and source.valid and source.player and source.skin == "skip"
		for i = 1, 5
			skipmetalscrap(target, source)
		end
	end
end, MT_RING_BOX)

//Lose 10 scrap metal when you die
addHook("MobjDeath", function(target, inflictor, source, damage, damagetype)
	if target and target.valid and target.player and target.player.skipscrap
	and not G_IsSpecialStage() and not (target.player.pflags&PF_FINISHED)
		if target.skin == "skip"
			S_StartSoundAtVolume(target, sfx_kc46, 96, target.player)
			for i = 1, 5
				if target.player.skipscrap
					skipmetalscrap(target)
				end
			end
		else
			target.player.skipscrap = max($-10,0)
		end
	end
end, MT_PLAYER)

//Lose 4 scrap when you get hit
addHook("MobjDamage", function(target, inflictor, source, damage, damagetype)
	if target and target.valid and target.player and target.player.skipscrap
	and target.skin == "skip" and target.player.rings and not target.player.powers[pw_shield]
	and not G_IsSpecialStage() and not (target.player.pflags&PF_FINISHED)
	and not (damagetype&DMG_INSTAKILL)
		for i = 1,2
			if target.player.skipscrap
				skipmetalscrap(target)
			end
		end
	end
end, MT_PLAYER)

//Collecting the Scrap Metal
addHook("TouchSpecial", function(special, toucher)
	if special and special.valid and toucher and toucher.valid
	and toucher.player and not toucher.player.bot
		if special.tics > TICRATE*19/2 or toucher.skin != "skip" return true end

		if toucher.player.skipscrap == nil
			toucher.player.skipscrap = 0
		end
		
		toucher.player.skipscrap = $+special.threshold
		
		if special.threshold > 1
			S_StartSoundAtVolume(toucher, sfx_skpms2, 192)
		else
			S_StartSoundAtVolume(toucher, sfx_skpms1, 192)
		end
		
		special.flags2 = $&~MF2_DONTDRAW
		special.flags = MF_NOCLIP|MF_NOCLIPTHING|MF_NOCLIPHEIGHT|MF_NOGRAVITY
		P_InstaThrust(special,0,0)
		special.scalespeed = $/2
		special.destscale = special.scale/2
		special.momz = 0
		special.shadowscale = 0
		special.reactiontime = 0
		special.tracer = toucher
		special.color = special.cusval
		special.colorized = false
		special.tics = -1
		special.fuse = TICRATE/2
		
		return true
	end
end, MT_SKIPMETALSCRAP)

//Scrap Metal Thinker
addHook("MobjThinker", function(mobj)
	if mobj.fuse and mobj.tracer and mobj.tracer.valid
		mobj.reactiontime = $+((mobj.fuse-(TICRATE/4))*(mobj.tracer.scale*5/4))
		P_TeleportMove(mobj, P_ReturnThrustX(nil, mobj.tracer.player.drawangle+ANGLE_180, mobj.tracer.radius/2)+mobj.tracer.x,
		P_ReturnThrustY(nil, mobj.tracer.player.drawangle+ANGLE_180, mobj.tracer.radius/2)+mobj.tracer.y,
		mobj.tracer.z+(mobj.tracer.height/2)-(mobj.tracer.height/3*P_MobjFlip(mobj.tracer))
		+(mobj.reactiontime*P_MobjFlip(mobj.tracer)))
	elseif mobj.sprite == SPR_SKRP and mobj.tics > 0
		if not P_IsObjectOnGround(mobj) and not (mobj.eflags & MFE_JUSTHITFLOOR)
			mobj.rollangle = $+ANGLE_11hh
			if (leveltime%2)
				P_SpawnGhostMobj(mobj)
			end
		end
		
		//Flashing white
		if (leveltime%(TICRATE/2))
			mobj.color = mobj.cusval
			mobj.colorized = false
		elseif mobj.tics > TICRATE*2
			mobj.color = SKINCOLOR_SUPERSILVER1
			mobj.colorized = true
		end
		
		//Flashing when about to despawn
		if mobj.tics <= TICRATE
			if (leveltime%2)
				mobj.flags2 = $|MF2_DONTDRAW
			else
				mobj.flags2 = $&~MF2_DONTDRAW
			end
		elseif mobj.tics <= TICRATE*2
			if (leveltime%4)
				mobj.flags2 = $|MF2_DONTDRAW
			else
				mobj.flags2 = $&~MF2_DONTDRAW
			end
		end
		
		//Attraction
		if mobj.tics <= TICRATE*19/2
			if mobj.target and mobj.target.valid and mobj.target.player
			and mobj.target.skin == "skip" and not P_PlayerInPain(mobj.target.player)
			and P_CheckSight(mobj, mobj.target)
				P_HomingAttack(mobj, mobj.target)
			elseif leveltime%2
				local distance = RING_DIST
				if mobj.skiplessmagnetic
					distance = $/2
				end
				for player in players.iterate
					if player.mo and player.mo.valid and player.mo.health
					and player.mo.skin == "skip" and P_CheckSight(mobj, player.mo)
					and P_AproxDistance(player.mo.x-mobj.x, player.mo.y-mobj.y) < distance
						distance = P_AproxDistance(player.mo.x-mobj.x, player.mo.y-mobj.y)
						mobj.target = player.mo
					end
				end
			end
		end
	end
end, MT_SKIPMETALSCRAP)

//Reset its scale when it poofs
addHook("MobjFuse", function(mobj)
	if mobj.tracer and mobj.tracer.valid
		S_StartSoundAtVolume(mobj.tracer, sfx_cdfm66, 96)
		mobj.scale = mobj.tracer.scale
		mobj.rollangle = 0
	end
end, MT_SKIPMETALSCRAP)

//Ray Cast thinker
addHook("MobjThinker", function(mobj)
	if not mobj.threshold
		mobj.threshold = 1
		mobj.fuse = TICRATE/2
	end
	if mobj.subsector and mobj.subsector.valid
	and mobj.subsector.sector and mobj.subsector.sector.valid
		if mobj.subsector.sector.lightlevel < 170
			P_SpawnLightningFlash(mobj.subsector.sector)
			mobj.subsector.sector.lightlevel = 170
		end
		for fof in mobj.subsector.sector.ffloors()
			if fof.valid and (fof.flags & FF_EXISTS)
			and (fof.bottomheight >= mobj.z
			or (mobj.z < fof.topheight
			and mobj.z+mobj.height > fof.bottomheight))
			and fof.sector.valid and fof.sector.lightlevel < 170
			P_SpawnLightningFlash(fof.sector)
			fof.sector.lightlevel = 170
			end
		end
	end
end, MT_SKIPRAYCAST)

//Start a Dive
addHook("SpinSpecial", function(player)
	if player.mo and player.mo.valid and player.mo.skin == "skip"
		//Cancel the menu by pressing spin
		if player.mo.skipmenu and not (player.pflags & PF_USEDOWN)
			S_StartSound(player.mo, sfx_cdfm23, player)
			player.mo.skipmenu = false
		end
		
		if P_PlayerInPain(player)
		or (player.pflags & PF_SLIDING)
		or player.powers[pw_carry] != CR_NONE
		or player.spectator
		or player.playerstate != PST_LIVE
		or not player.mo.health
		or player.panim == PA_PAIN
		or player.powers[pw_super] == 1
		or player.iseggrobo
		or player.powers[pw_nocontrol]
		or player.mo.skipdove
		or player.exiting
		or player.mo.skipdivehit
		or player.mo.skipcrouching
		or player.mo.skipsteam
		or player.mo.eflags & MFE_GOOWATER
		or player.pflags & PF_USEDOWN
		or (player.cmd.buttons & BT_JUMP and not (player.pflags & PF_JUMPDOWN))
		or player.secondjump == 69
		or (P_IsObjectOnGround(player.mo) and P_GetPlayerControlDirection(player) == 0
		and not (player.pflags & PF_SPINNING))
		return end
		
		//Slide Recovery
		if player.pflags & PF_SPINNING and P_IsObjectOnGround(player.mo)
			player.mo.state = S_PLAY_SKIPCANCEL
			player.pflags = $&~PF_DRILLING
			player.mo.skipdove = false
			player.secondjump = 0
			S_StartSound(player.mo,sfx_s3k9a)
			
			if player.mo.skipperfectwindow
				//The dive aims in the direction you're facing in Simple
				if player.pflags & PF_ANALOGMODE
					P_InstaThrust(player.mo, inputangle(player), skipdive(player))
					player.drawangle = inputangle(player)
				else
					P_InstaThrust(player.mo, player.mo.angle, skipdive(player))
					player.drawangle = player.mo.angle
				end
				skipdust(player)
				S_StartSoundAtVolume(player.mo, sfx_s3k81, 128)
				skipcircle(player.mo, MT_DUST, 8 << FRACBITS, false, 0)
				if player == displayplayer
					P_StartQuake(10*FRACUNIT, 1)
				end
			end
		
		//Charge Dive
		elseif (player.powers[pw_shield] & SH_NOSTACK) == SH_ARMAGEDDON
		and not P_IsObjectOnGround(player.mo)
			player.mo.state = S_PLAY_ROLL
			player.mo.chargedive = TICRATE*2
			S_StartSoundAtVolume(player.mo, sfx_skpchg, 196)
			player.pflags = $|PF_DRILLING
			player.mo.skipdove = true
			
		//Normal Dive
		else
			player.mo.state = S_PLAY_SKIPALTDIVE
				
			//The dive aims in the direction you're facing in Simple
			if player.pflags & PF_ANALOGMODE
				P_InstaThrust(player.mo, inputangle(player), skipdive(player))
				player.drawangle = inputangle(player)
			else
				P_InstaThrust(player.mo, player.mo.angle, skipdive(player))
				player.drawangle = player.mo.angle
			end
			
			if player.mysticsuper -- Mystic Super dive?
			P_SpawnGhostMobj(player.mo)
				if (player.powers[pw_shield] > 1) or not (player.secondjump)
				player.pflags = $|PF_DRILLING --"Normal first dive"
				player.mo.skipdove = true
				elseif player.secondjump
				player.secondjump = 899
				player.mo.skipdove = false
				end
			else
			player.pflags = $|PF_DRILLING
			player.mo.skipdove = true
			end
			S_StartSound(player.mo,sfx_s3k98)
			skipcircle(player.mo, MT_DUST, 8 << FRACBITS, true, player.drawangle)
			if player == displayplayer
				P_StartQuake(5*FRACUNIT, 1)
			end
		end
		
		//The Charge dive sets your vertical momentum to zero
		if player.mo.chargedive
			player.mo.momz = 0
		//Dives on the ground and after double jumps have less vertical power
		elseif P_IsObjectOnGround(player.mo) or player.secondjump
			if player.mysticsuper and not (player.powers[pw_shield] > 1)
			and not P_IsObjectOnGround(player.mo)
				P_SetObjectMomZ(player.mo, -FRACUNIT, true) --Infinite dives, but no infinite height!
			elseif player.pflags & PF_SPINNING or player.speed > 5*player.mo.scale
				if player.mo.eflags&MFE_UNDERWATER
					P_SetObjectMomZ(player.mo, (player.jumpfactor*(39/4)/4), false)
				else
					P_SetObjectMomZ(player.mo, (player.jumpfactor*(39/4)/2), false)
				end
			end
		elseif player.mo.eflags&MFE_UNDERWATER
			P_SetObjectMomZ(player.mo, (player.jumpfactor*(39/4)/2), false)
		else
			P_SetObjectMomZ(player.mo, player.jumpfactor*(39/4), false)
		end
		
		//Shield Abilities
		//Flame Shield/Burst Dive is handled within the skipdive function
		//The Armageddon Shield/Charge Dive is handled shortly before this
		if player.mo.state == S_PLAY_SKIPALTDIVE
			//High Dive
			if (player.powers[pw_shield] & SH_NOSTACK) == SH_WHIRLWIND
			and not P_IsObjectOnGround(player.mo) and not player.secondjump
				S_StartSound(player.mo, sfx_wdjump)
				player.mo.momz = $*3/2
				
			//Homing Dive
			elseif (player.powers[pw_shield] & SH_NOSTACK) == SH_ATTRACT
				local lockonshield = P_LookForEnemies(player, false, false)
				player.mo.tracer = lockonshield
				player.mo.target = lockonshield
				if lockonshield and lockonshield.valid
					player.pflags = $|PF_SHIELDABILITY
					player.mo.angle = R_PointToAngle2(player.mo.x, player.mo.y, lockonshield.x, lockonshield.y)
					S_StartSound(player.mo, sfx_s3k40)
					player.homing = 3*TICRATE
				end
				
			//Bounce Dive
			elseif (player.powers[pw_shield] & SH_NOSTACK) == SH_BUBBLEWRAP
			and not P_IsObjectOnGround(player.mo)
				player.pflags = $|PF_SHIELDABILITY
				player.secondjump = 0
				S_StartSound(player.mo, sfx_s3k44)
				P_SetObjectMomZ(player.mo, -24*FRACUNIT, false)
			
			//Meteor Dive
			elseif (player.powers[pw_shield] & SH_NOSTACK) == SH_ELEMENTAL
			and not P_IsObjectOnGround(player.mo)
				P_SetObjectMomZ(player.mo, -24*FRACUNIT, false)
				
			//Wire Dive
			elseif (player.powers[pw_shield] & SH_NOSTACK) == SH_THUNDERCOIN
			and not P_IsObjectOnGround(player.mo)
				player.pflags = $|PF_SHIELDABILITY
				player.mo.momz = 0
				player.mo.skipwiredivedir = player.drawangle
				P_InstaThrust(player.mo, player.mo.skipwiredivedir, 60*player.mo.scale)
				player.mo.skipwiredive = TICRATE*3/2
				P_NukeEnemies(player.mo, player.mo, 0) //Purely for visual effect
				P_RadiusAttack(player.mo, player.mo, RING_DIST, DMG_ELECTRIC)
				S_StartSound(player.mo, sfx_s3k45)
			end
		end
		
		player.pflags = $|PF_JUMPED&~PF_STARTJUMP&~PF_SPINNING|PF_NOJUMPDAMAGE
	end
end)

//Slide recovery but for the Jump button
addHook("JumpSpecial", function(player)
	if player.mo and player.mo.valid and player.mo.skin == "skip"
		//No jumping while crouching or crafting
		//Not using PF_JUMPSTASIS since that makes you jump if you hold the button
		if player.mo.skipcrouching or player.mo.skipmenu return true end
	
		//Allow double jumps out of the Flame/Elemental/Bubble Shield
		if ((player.powers[pw_shield] & SH_NOSTACK) == SH_FLAMEAURA
		or (player.powers[pw_shield] & SH_NOSTACK) == SH_ELEMENTAL
		or (player.powers[pw_shield] & SH_NOSTACK) == SH_BUBBLEWRAP)
		and player.pflags&PF_SHIELDABILITY and player.pflags&PF_JUMPED
		and not (player.pflags&PF_THOKKED) and not (player.pflags&PF_JUMPDOWN)
			player.pflags = $&~PF_SHIELDABILITY
		end
		
		if (P_PlayerInPain(player)
		or (player.pflags & PF_SLIDING)
		or player.powers[pw_carry] != CR_NONE
		or player.spectator
		or player.playerstate != PST_LIVE
		or not player.mo.health
		or player.panim == PA_PAIN
		or player.powers[pw_super] == 1
		or player.iseggrobo
		or player.powers[pw_nocontrol]
		or player.mo.skipdove
		or player.exiting
		or player.mo.skipdivehit
		or player.mo.skipcrouching
		or player.mo.skipsteam
		or player.mo.eflags & MFE_GOOWATER
		or player.pflags & PF_JUMPDOWN
		or player.secondjump == 69
		or (P_IsObjectOnGround(player.mo) and P_GetPlayerControlDirection(player) == 0
		and not (player.pflags & PF_SPINNING)))
		and not (player.mo.skipdove and player.mo.eflags & MFE_JUSTHITFLOOR
		and not (player.pflags & PF_JUMPDOWN))
		return end
		
		//Slide Recovery
		if player.pflags & PF_SPINNING and P_IsObjectOnGround(player.mo)
		or (player.mo.skipdove and player.mo.eflags & MFE_JUSTHITFLOOR
		and not (player.pflags & PF_JUMPDOWN))
			player.mo.state = S_PLAY_SKIPCANCEL
			player.secondjump = 0
			S_StartSound(player.mo,sfx_s3k9a)
			
			if player.mo.skipperfectwindow
			or (player.mo.skipdove and player.mo.eflags & MFE_JUSTHITFLOOR
			and not (player.pflags & PF_JUMPDOWN))
				//The dive aims in the direction you're facing in Simple
				if player.pflags & PF_ANALOGMODE
					P_InstaThrust(player.mo, inputangle(player), skipdive(player))
					player.drawangle = inputangle(player)
				else
					P_InstaThrust(player.mo, player.mo.angle, skipdive(player))
					player.drawangle = player.mo.angle
				end
				skipdust(player)
				S_StartSoundAtVolume(player.mo, sfx_s3k81, 128)
				skipcircle(player.mo, MT_DUST, 8 << FRACBITS, false, 0)
				if player == displayplayer
					P_StartQuake(10*FRACUNIT, 1)
				end
			end
			
			if player.mo.eflags&MFE_UNDERWATER
				P_SetObjectMomZ(player.mo, (player.jumpfactor*(39/4)/4), false)
			else
				P_SetObjectMomZ(player.mo, (player.jumpfactor*(39/4)/2), false)
			end
			
			player.pflags = $|PF_JUMPED&~PF_STARTJUMP|PF_NOJUMPDAMAGE&~PF_SPINNING&~PF_DRILLING
			player.mo.skipdove = false
			
			return true
		end
	end
end)

//Double Jump and Dive Cancel
//CA_DOUBLEJUMP is for nerds
addHook("AbilitySpecial", function(player)
	if player.mo and player.mo.valid and player.mo.skin == "skip"
	  if (player.mysticsuper and player.secondjump > 898)
	  return true
	  end
	  if (not (player.pflags & PF_THOKKED) or player.mo.chargedive
	  or (player.secondjump < 2 and player.mo.skipwiredive))
		player.pflags = $ & ~PF_JUMPED
		P_DoJump(player, false)
		player.pflags = $|PF_THOKKED
		if player.mo.skipdove
			player.mo.state = S_PLAY_SKIPCANCEL
		else
			player.mo.state = S_PLAY_SKIPDOUBLEJUMP
		end
		skipdust(player)
		player.mo.skipdove = false
		player.pflags = $&~PF_DRILLING
		if player.mo.chargedive
			local i=0 while i<10 S_StopSound(player.mo) i=$+1 end
			player.mo.chargedive = 0
			player.mo.momz = $/2
			if player.secondjump
				player.secondjump = 69
			else
				player.secondjump = $+1
			end
		else
			player.secondjump = $+1
		end
		S_StartSound(player.mo,sfx_skpdbl)
	   end
	return true end
end)

//Prevent Bonking on monitors when you slide into them
//Uses the monitor breaking code from the source code
addHook("MobjMoveCollide", function(tmthing, thing)
	if tmthing and tmthing.valid and tmthing.player and tmthing.skin == "skip"
	and (tmthing.skipdove or tmthing.state == S_PLAY_SKIPSLIDE)
	and not tmthing.skipdivehit and thing and thing.valid and thing.health
	and thing.flags&MF_MONITOR and not (thing.flags&MF_GRENADEBOUNCE)
	and not ((thing.type == MT_RING_REDBOX and tmthing.player.ctfteam != 1) or (thing.type == MT_RING_BLUEBOX and tmthing.player.ctfteam != 2))
	and (not (thing.flags & MF_SOLID) or P_PlayerCanDamage(tmthing.player, thing))
		if (thing.z - thing.scale <= tmthing.z + tmthing.height
		and thing.z + thing.height + thing.scale >= tmthing.z)
			local player = tmthing.player
			local flipval = P_MobjFlip(thing) // Save this value in case monitor gets removed.
			// Going down? Then bounce back up.
			if P_DamageMobj(thing, tmthing, tmthing, 1, 0) // break the monitor
			and flipval*(player.mo.momz) < 0 // monitor is on the floor and you're going down, or on the ceiling and you're going up
			and not ((player.powers[pw_shield] & SH_NOSTACK) == SH_ELEMENTAL
			and player.pflags&PF_SHIELDABILITY) // you're not piercing through the monitor...
				if (player.powers[pw_shield] & SH_NOSTACK) == SH_BUBBLEWRAP
				and player.pflags&PF_SHIELDABILITY
					P_DoBubbleBounce(player)
				else
					player.mo.momz = $*-1 // Therefore, you should be thrust in the opposite direction, vertically.
				end
			end
			player.mo.z = $-player.mo.momz // to ensure proper collision.
			return false
		end
	end
end, MT_PLAYER)

//Allow Double Jumping off THZ steam
addHook("MobjMoveCollide", function(tmthing, thing)
	if tmthing and tmthing.valid and tmthing.player and tmthing.skin == "skip"
	and thing and thing.valid and thing.type == MT_STEAM
	and (thing.z - thing.scale <= tmthing.z + tmthing.height
	and thing.z + thing.height + thing.scale >= tmthing.z)
		tmthing.skipsteam = true
	end
end, MT_PLAYER)

//Same for those dumb fans
addHook("MobjMoveCollide", function(tmthing, thing)
	if tmthing and tmthing.valid and tmthing.player and tmthing.skin == "skip"
	and thing and thing.valid and thing.type == MT_FAN
	and tmthing.z - thing.z <= thing.health << FRACBITS
	and P_MobjFlip(tmthing)*tmthing.momz >= FixedMul(thing.info.mass, thing.scale)
		tmthing.skipsteam = true
	end
end, MT_PLAYER)

//Bonking into walls while diving or sliding
addHook("MobjMoveBlocked", function(mobj)
	if mobj and mobj.valid and mobj.player and mobj.skin == "skip"
	and (mobj.skipdove or mobj.state == S_PLAY_SKIPSLIDE)
	and not mobj.skipdivehit and not mobj.readyforbonk
	and mobj.ceilingz - mobj.floorz >= FixedMul(skins[mobj.skin].height, mobj.scale)
		mobj.readyforbonk = mobj.player.speed -- Save the player's speed value. Use it in the playerthink. 
		mobj.readyforbonkx = mobj.momx --Just CTRL+F "Bonk Code" to find the continuation of this.
		mobj.readyforbonky = mobj.momy
	end
end, MT_PLAYER)

//For the Smug Dance
//...even though it doesn't seem like it does anything
addHook("ShouldJingleContinue", function(player, musname)
	if true return end
	if musname != "SMUGDANCE" return end
	if player and player.mo and player.mo.skin == "skip" and player.skipsmug
		return true
	else
		return false
	end
end)

//Main Thinker	
addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid and player.mo.skin == "skip"
		//Crafting Menu Movement
		if player.skipyoffset == nil
			player.skipyoffset = 0
		elseif player.mo.skipmenu
			if player.skipyoffset < 14
				player.skipyoffset = $+1
			end
		elseif player.skipyoffset
			player.skipyoffset = $-1
		end
		
		//Make it so you can double jump off steam
		if player.mo.skipsteam
			resetskip(player)
			if not P_IsObjectOnGround(player.mo)
				player.secondjump = 0
				player.pflags = $|PF_JUMPED&~PF_THOKKED
			end
		end
	
		//Remember what shield you have so that when you change levels you keep it
		if player.skipshield != (player.powers[pw_shield] & SH_NOSTACK)
		and not G_IsSpecialStage()
			player.skipshield = (player.powers[pw_shield] & SH_NOSTACK)
		end
		
		//Directional Tapping
		if player.cmd.forwardmove < 25 then
			player.forwardtapready = true
			player.forwardtapping = false
		elseif player.forwardtapready then
			player.forwardtapping = true
			player.forwardtapready = false
		else
			player.forwardtapping = false
		end
		
		if player.cmd.sidemove < 25 then
			player.righttapready = true
			player.righttapping = false
		elseif player.righttapready then
			player.righttapping = true
			player.righttapready = false
		else
			player.righttapping = false
		end
		
		if player.cmd.sidemove > -25 then
			player.lefttapready = true
			player.lefttapping = false
		elseif player.lefttapready then
			player.lefttapping = true
			player.lefttapready = false
		else
			player.lefttapping = false
		end
		
		if not (player.cmd.buttons & BT_JUMP) then
			player.jumptapready = true
			player.jumptapping = false
		elseif player.jumptapready then
			player.jumptapping = true
			player.jumptapready = false
		else
			player.jumptapping = false
		end
		
		//Detect if we're tapping Custom 1
		if not (player.cmd.buttons & BT_CUSTOM1) then
			player.customtapready = true
			player.customtapping = false
		elseif player.customtapready then
			player.customtapping = true
			player.customtapready = false
		else
			player.customtapping = false
		end
		
		//Detect when we press Toss Flag
		if not (player.cmd.buttons & BT_TOSSFLAG)
			player.skiptosstapready = true
			player.skiptosstapping = false
		elseif player.skiptosstapready 
		and not (player.hugging) then
			player.skiptosstapping = true
			player.skiptosstapready = false
		else
			player.skiptosstapping = false
		end
		
		//Flashlight Toggle
		if player.skiplighton
			if player.customtapping
				player.skiplighton = false
			end
		elseif player.customtapping
			player.skiplighton = true
		end
		
		//Flashlight
		if not P_PlayerInPain(player) and player.panim != PA_PAIN
		and not player.mo.skipdivehit and player.mo.health
		and player.skiplighton
			if (player.skipflashlight and player.skipflashlight.valid)
				P_SPMAngle(player.mo, MT_SKIPRAYCAST, player.drawangle, 0)
			else
				S_StartSoundAtVolume(player.mo, sfx_skpflg, 128)
				player.skipflashlight = P_SpawnMobjFromMobj(player.mo,0,0,0,MT_SKIPFLASHLIGHT)
				player.skipflashlight.target = player.mo
				player.skipflashlight.color = SKINCOLOR_WHITE
			end
		elseif player.skipflashlight and player.skipflashlight.valid
			if not player.skiplighton
				S_StartSoundAtVolume(player.mo, sfx_skpflg, 128)
			end
			P_KillMobj(player.skipflashlight)
		end
		
		//Jump Squat
		//Why not
		if player.mo.state == S_PLAY_JUMP
			player.mo.state = S_PLAY_SKIPJUMP
			player.panim = PA_JUMP
			player.mo.frame = 2
		end
		
		if player.mo.state == S_PLAY_RUN and not P_IsObjectOnGround(player.mo)
			player.mo.state = S_PLAY_SKIPCANCEL
		end
		
		//Running SFX code
		//Since Starfy likely isn't gonna see the light of day, might as well
		if player.canrunsfx and player.panim == PA_RUN and P_IsObjectOnGround(player.mo)
		and (player.mo.frame == 1 or player.mo.frame == 3
		or player.mo.frame&FF_FRAMEMASK == 1 or player.mo.frame&FF_FRAMEMASK == 3)
			S_StartSoundAtVolume(player.mo, sfx_sfstep, 128)
			player.canrunsfx = false
		elseif player.panim == PA_RUN and not player.canrunsfx
		and (player.mo.frame == 0 or player.mo.frame == 2
		or player.mo.frame&FF_FRAMEMASK == 0 or player.mo.frame&FF_FRAMEMASK == 2)
			player.canrunsfx = true
		end
		
		//Running particles
		//Literally just the Spindash dust code from SRB2 Sonic which was
		//from SRB2's source code
		if (player.panim == PA_RUN or (player.mo.state == S_PLAY_SKIPSLIDE
		and (player.powers[pw_shield] & SH_NOSTACK) != SH_ELEMENTAL))
		and P_IsObjectOnGround(player.mo) and not (player.pflags&PF_STARTDASH)
			local i = 0 while i <= (leveltime%7)/2 // 1, 2, 3 or 4 particles
				local particle = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_SPINDUST)
				if player.mo.state != S_PLAY_SKIPSLIDE
					P_TryMove(particle, particle.x+P_ReturnThrustX(nil,player.drawangle+ANGLE_180,player.mo.radius),
					particle.y+P_ReturnThrustY(nil,player.drawangle+ANGLE_180,player.mo.radius), true)
				end

				if player.mo.eflags & (MFE_TOUCHWATER|MFE_UNDERWATER)
					particle.state = S_SMALLBUBBLE
				elseif (player.powers[pw_shield] & SH_NOSTACK) == SH_ELEMENTAL
					particle.state = S_SPINDUST_FIRE1
				end
				
				particle.target = player.mo
				particle.destscale = (2*player.mo.scale)/3
				P_SetScale(particle, particle.destscale)
				if (player.mo.eflags & MFE_VERTICALFLIP) // readjust z position if needed
					particle.z = player.mo.z + player.mo.height - particle.height
				end
				local prandom = {}
				prandom[0] = P_RandomFixed()<<2 // P_RandomByte()<<10
				prandom[1] = P_RandomRange(-30, 30) // P_RandomRange(-ANG30/FRACUNIT, ANG30/FRACUNIT)*FRACUNIT
				prandom[2] = P_RandomFixed()<<3 // P_RandomByte()<<11
				P_SetObjectMomZ(particle, player.maxdash/50 + prandom[0], false)
				P_InstaThrust(particle,
						player.drawangle + (prandom[1]*ANG1),
						-FixedMul(player.maxdash/12 + FRACUNIT + prandom[2], player.mo.scale))
				particle.momx = $+player.mo.momx
				particle.momy = $+player.mo.momy
				P_TryMove(particle, particle.x+particle.momx, particle.y+particle.momy, true)
				
				i = $+1
			end
		end
		
		-- Mystic Super shenanigans
		if player.mysticsuper
			if player.powers[pw_shield] --Picked up a shield? Save it for later.
			player.lastmysticshield = player.powers[pw_shield]
			player.powers[pw_shield] = 0
			P_SpawnShieldOrb(player)
			end
			
			if (player.mo.state == S_PLAY_SKIPALTDIVE or player.mo.state == S_PLAY_SKIPDIVE)
			and (player.speed > 120*FRACUNIT)
			player.mo.ghs = P_SpawnGhostMobj(player.mo)
			player.mo.ghs.tics = P_RandomRange(3,4)
			
			elseif (player.mo.state == S_PLAY_SKIPSLIDE) --FLUDD is finally here
			and (player.cmd.forwardmove > 0) and P_IsObjectOnGround(player.mo) and (player.speed < 140*FRACUNIT)
			
			P_Thrust(player.mo, player.mo.angle, 76000)
			player.mo.ghs = P_SpawnGhostMobj(player.mo)
			player.mo.ghs.tics = P_RandomRange(3,5)
			end
			
		elseif player.lastmysticshield
			player.powers[pw_shield] = player.lastmysticshield
			P_SpawnShieldOrb(player)
			player.lastmysticshield = nil
		end
		
		//Bonk Code, activated after the mobjcollide and significant speed was lost.
		
		local mobj = player.mo -- Just for laziness.
		if mobj.readyforbonk	
			if ( (mobj.readyforbonk > 12*FRACUNIT and player.speed < mobj.readyforbonk/4)
			or (player.powers[pw_shield] & ~(SH_FORCEHP|SH_STACK)) == SH_FORCE
			or mobj.skipwiredive )
			and player.powers[pw_justlaunched] != 2
				mobj.momx = mobj.readyforbonkx //Necessary for P_BounceMove to function properly.
				mobj.momy = mobj.readyforbonky
				P_BounceMove(mobj)
				mobj.momx = $/2 mobj.momy = $/2
				P_SetObjectMomZ(mobj, mobj.player.jumpfactor*(39/4), false)
				mobj.skipdove = false
				mobj.player.pflags = $&~PF_DRILLING&~PF_SPINNING|PF_JUMPED
				//Force Walljump
				if (player.powers[pw_shield] & ~(SH_FORCEHP|SH_STACK)) == SH_FORCE
					mobj.state = S_PLAY_SKIPCANCEL
					mobj.player.pflags = $|PF_SHIELDABILITY
					mobj.player.secondjump = 69
					if not P_IsObjectOnGround(mobj)
						mobj.momz = $*5/4
					end
					S_StartSound(mobj, sfx_ngskid)
				else
					skipcircle(mobj, MT_SUPERSPARK, 16 << FRACBITS, true,
					R_PointToAngle2(mobj.readyforbonkx, mobj.readyforbonky, 0, 0))
					if mobj.player == displayplayer
						P_StartQuake(10*FRACUNIT, 7)
					end
					if P_IsObjectOnGround(mobj) --Fixes a pain bug
					mobj.z = $+(FRACUNIT*P_MobjFlip(mobj))
					end
					mobj.player.pflags = $&~PF_SHIELDABILITY
					mobj.skipdivehit = true
					S_StartSound(mobj,sfx_s3k9e)
				end
			end
		mobj.readyforbonk = nil
		mobj.readyforbonkx = 0
		mobj.readyforbonky = 0
		end
		
		//Jump Dust
		if player.pflags&PF_STARTJUMP and not (player.pflags&PF_THOKKED)
		and not player.secondjump
			if not player.juum
				player.juum = true
				P_SpawnMobjFromMobj(player.mo,0,0,0,MT_DUST)
			end
		else
			player.juum = false
		end
		
		//Disallows the rest of the code in certain circumstances
		if P_PlayerInPain(player)
		or (player.pflags & PF_SLIDING)
		or player.powers[pw_carry] != CR_NONE
		or player.spectator
		or player.playerstate != PST_LIVE
		or not player.mo.health
		or player.panim == PA_PAIN
		or player.powers[pw_super] == 1
		or player.iseggrobo
		or (player.powers[pw_nocontrol] and not player.mo.skipcrouching)
			resetskip(player)
		return end
		
		//Charge Dive stuff
		if player.mo.chargedive and (player.mo.skipdivehit or P_IsObjectOnGround(player.mo))
			local i=0 while i<10 S_StopSound(player.mo) i=$+1 end
			if player.mo.skipdivehit
				S_StartSound(player.mo,sfx_s3k9e)
			end
			player.mo.chargedive = 0
		elseif player.mo.chargedive
			player.mo.chargedive = $-1
			player.drawangle = player.mo.angle
			player.mo.momz = 0
			if not (player.cmd.buttons&BT_USE)
				local maxthrust = abs(player.mo.chargedive-(TICRATE*2))*player.mo.scale*3/2
				local minthrust = skipdive(player)
				P_InstaThrust(player.mo, player.mo.angle,
				max(maxthrust, minthrust))
				local i=0 while i<10 S_StopSound(player.mo) i=$+1 end
				S_StartSound(player.mo,sfx_s3k98)
				if maxthrust > minthrust
					//S_StartSoundAtVolume(player.mo, sfx_s3k81, 196)
					S_StartSound(player.mo,sfx_kc5b)
					skipcircle(player.mo, MT_SUPERSPARK, 8 << FRACBITS, true, player.drawangle)
					player.mo.state = S_PLAY_SKIPDIVE
				else
					skipcircle(player.mo, MT_DUST, 8 << FRACBITS, true, player.drawangle)
					player.mo.state = S_PLAY_SKIPALTDIVE
				end
				
				if player.secondjump or maxthrust > minthrust
					if player.mo.eflags&MFE_UNDERWATER
						P_SetObjectMomZ(player.mo, (player.jumpfactor*(39/4)/4), false)
					else
						P_SetObjectMomZ(player.mo, (player.jumpfactor*(39/4)/2), false)
					end
				elseif player.mo.eflags&MFE_UNDERWATER
					P_SetObjectMomZ(player.mo, (player.jumpfactor*(39/4)/2), false)
				else
					P_SetObjectMomZ(player.mo, player.jumpfactor*(39/4), false)
				end
				player.mo.chargedive = 0
		
			elseif player.mo.chargedive <= 0
				P_InstaThrust(player.mo, player.mo.angle, 128*player.mo.scale)
				P_BlackOw(player)
				skipcircle(player.mo, MT_SUPERSPARK, 8 << FRACBITS, true, player.drawangle)
				player.mo.state = S_PLAY_SKIPDIVE
				
				if player.mo.eflags&MFE_UNDERWATER
					P_SetObjectMomZ(player.mo, (player.jumpfactor*(39/4)/4), false)
				else
					P_SetObjectMomZ(player.mo, (player.jumpfactor*(39/4)/2), false)
				end
				player.mo.chargedive = 0
				
			elseif player.mo.chargedive < (TICRATE*2)-5
				player.mo.momx = FixedMul($, FRACUNIT*94/100)
				player.mo.momy = FixedMul($, FRACUNIT*94/100)
				if (player.mo.chargedive < 15) --Make it more obvious when you're about to blow up your shield.
					if (player.mo.chargedive == 14)
					S_StartSound(player.mo, sfx_kc4d)
					end
					P_SpawnMobj(player.mo.x+P_RandomRange(-90, 90)*player.mo.scale, player.mo.y+P_RandomRange(-90, 90)*player.mo.scale, player.mo.z+P_RandomRange(-20, 70)*player.mo.scale, MT_SPARK)
				end
				if not (leveltime%2)
					local ghost = P_SpawnGhostMobj(player.mo)
					if ghost and ghost.valid
						ghost.momx = player.mo.momx
						ghost.momy = player.mo.momy
						ghost.momz = player.mo.momz
						ghost.destscale = player.mo.scale*3/2
						//Don't draw the ghosts if you're in first person
						//and you're the one spawning them (hopefully netsafe)
						if not verydangerouschasecamvariable and player == displayplayer
							ghost.flags2 = $|MF2_DONTDRAW
						end
					end
				end
			end
		end
		
		//Wire Dive stuff
		if player.mo.skipwiredive
			if player.mo.skipdove
				player.mo.skipwiredive = $-1
			else
				player.mo.skipwiredive = 0
			end
			P_SpawnGhostMobj(player.mo)
			if player.mo.skipwiredive == 0
				if player.secondjump > 1
					player.secondjump = 69
				end
				player.pflags = $&~PF_SHIELDABILITY
				player.mo.momx = $/12
				player.mo.momy = $/12
				S_StartSoundAtVolume(player.mo, sfx_s3kd6s, 128)
			else
				player.mo.momz = 0
				P_InstaThrust(player.mo, player.mo.skipwiredivedir, 80*player.mo.scale)
				player.drawangle = player.mo.skipwiredivedir
			end
		end
		
		//Restore your jump abilities when you land with the Bubble Shield
		if player.secondjump == 255
			player.mo.state = S_PLAY_SKIPDIVE
			player.pflags = $|PF_JUMPED&~PF_THOKKED&~PF_SHIELDABILITY
			player.mo.momz = $*3/2
			player.secondjump = 0
		end
		
		//Cancel the Elemental Stomp right before you hit the ground
		if (player.powers[pw_shield] & SH_NOSTACK) == SH_ELEMENTAL
		and player.pflags&PF_SHIELDABILITY
			local floor = P_FloorzAtPos(player.mo.x, player.mo.y, player.mo.z, player.mo.height)
			local z = player.mo.z
			if (player.mo.eflags&MFE_VERTICALFLIP)
				z = player.mo.z+player.mo.height
				if player.mo.ceilingz == floor
					floor = player.mo.floorz
				else
					floor = player.mo.ceilingz
				end
			end
			if abs(z-floor) <= abs(player.mo.momz)
				player.pflags = $&~PF_SHIELDABILITY
				if player == displayplayer
					P_StartQuake(40*FRACUNIT, 7)
				end
				P_ElementalFire(player, true)
				S_StartSound(player.mo,sfx_s3k5f)
				P_RadiusAttack(player.mo, player.mo, RING_DIST, DMG_FIRE)
				skipcircle(player.mo, MT_DUST, 32 << FRACBITS, false, 0)
				player.mo.momx = $*4/3
				player.mo.momy = $*4/3
			end
		end
		
		//Reset the variables on landing on the ground
		if player.mo.eflags & MFE_JUSTHITFLOOR and not (player.pflags&PF_JUMPED)
			local stupid = false
			//Start a slide after a dive
			if player.mo.skipdove
				stupid = true
				player.mo.state = S_PLAY_SKIPSLIDE
				player.mo.momx = $*3/4
				player.mo.momy = $*3/4
				player.pflags = $|PF_SPINNING
			end
			resetskip(player)
			//Window of time for the perfect dive recovery
			if stupid then player.mo.skipperfectwindow = 5 end
			
		//Decrease the timer for it
		elseif player.mo.skipperfectwindow
			player.mo.skipperfectwindow = $-1
		end
		
		//Cancel the dive or bonk if you go into goop or hit a spring
		if (player.mo.skipdove or player.mo.skipdivehit)
		and (player.mo.eflags & MFE_GOOWATER or player.mo.eflags & MFE_SPRUNG)
			player.mo.state = S_PLAY_SKIPCANCEL
			resetskip(player)
		end
		
		//Ya sprung? Ya get your jump ability back
		if player.mo.eflags & MFE_SPRUNG and not P_IsObjectOnGround(player.mo)
			player.pflags = $|PF_JUMPED&~PF_THOKKED
		end
		
		//Crouching
		if player.mo.skipcrouching
			if player.mo.ceilingz - player.mo.floorz < FixedMul(skins[player.mo.skin].height, player.mo.scale)
				player.pflags = $ | PF_FULLSTASIS
			end
			//Cancel the crouch
			if not ((player.cmd.buttons & BT_USE) or player.mo.skipmenu)
			or not P_IsObjectOnGround(player.mo)
				if P_IsObjectOnGround(player.mo)
					player.mo.state = S_PLAY_STND
				else
					player.mo.state = S_PLAY_SPRING
				end
				player.mo.skipmenu = false
				player.mo.skipcrouching = false
				player.height = skins[player.mo.skin].height
				player.normalspeed = skins[player.mo.skin].normalspeed
			//Normal stuff
			else
				if player.mo.skipmenu
					player.mo.state = S_PLAY_WAIT
					player.mo.frame = (leveltime%64)/16 //I really hate SRB2
				else
					player.mo.state = S_PLAY_SKIPCROUCH
					player.mo.frame = (leveltime%16)/4 //I really REALLY hate SRB2
					player.panim = PA_IDLE
				end
				player.powers[pw_noautobrake] = max($,1)
				player.height = skins[player.mo.skin].spinheight
				player.normalspeed = 0
				//Monitor Crafting
				if player.mo.skipmenu and (player.exiting or G_IsSpecialStage())
					player.mo.skipmenu = false
				elseif player.mo.skipmenu
					local cost = skipcostlist[player.mo.skipselection] //Cost
					if player.mo.skipgold cost = $*2 end //Gold Multiplier
					if All7Emeralds(emeralds) cost = $*40/54 end //Emerald Discount
					
					//Set our angle so we don't turn while in the menu
					player.drawangle = player.mo.skipcrouchdir
					
					//Menu Selection
					if player.forwardtapping
						player.mo.skipgold = not($)
						S_StartSound(player.mo, sfx_menu1, player)
					elseif player.righttapping
						player.mo.skipselection = $+1
						if player.mo.skipselection > skiptotalcraft
							player.mo.skipselection = 0
						end
						S_StartSound(player.mo, sfx_s3kb7, player)
					elseif player.lefttapping
						player.mo.skipselection = $-1
						if player.mo.skipselection < 0
							player.mo.skipselection = skiptotalcraft
						end
						S_StartSound(player.mo, sfx_s3kb7, player)
						
					//Crafting
					elseif player.jumptapping
						//Spawn it if we have enough scraps
						if player.skipscrap >= cost or CV_FindVar("infinitescrap").value
							local monitor
							if player.mo.skipgold
								monitor = P_SpawnMobjFromMobj(player.mo,0,0,0,
								skipgoldcraftlist[player.mo.skipselection])
							else
								monitor = P_SpawnMobjFromMobj(player.mo,0,0,0,
								skipcraftlist[player.mo.skipselection])
							end
							//Set the monitor's things and apply the cost
							if monitor and monitor.valid
								player.mo.flags = $|MF_NOCLIPTHING
								P_TryMove(monitor, player.mo.x+P_ReturnThrustX(nil, player.drawangle, player.mo.radius*4),
								player.mo.y+P_ReturnThrustY(nil, player.drawangle, player.mo.radius*4), true)
								player.mo.flags = $&~MF_NOCLIPTHING
								S_StartSound(player.mo,sfx_kc5b) --sound effect for emphasis
								S_StartSound(player.mo, sfx_addfil, player)
								S_StartSoundAtVolume(player.mo, sfx_cdpcm8, 196)
								skipcircle(monitor, MT_DUST, 8 << FRACBITS, true, player.drawangle)
								skipcircle(monitor, MT_DUST, 8 << FRACBITS, true, player.drawangle+ANGLE_90)
								if not CV_FindVar("infinitescrap").value
									player.skipscrap = $-cost -- bap, there goes some of your scrap
								end
								monitor.skipthrown = true
								if not (monitor.flags&MF_GRENADEBOUNCE)
									monitor.skipskip = player.mo
									monitor.skipgrace = TICRATE
								end
								P_SetScale(monitor, player.mo.scale/2)
								player.mo.skipmenu = false
								
							else //If the monitor somehow got removed, play an error sound
								S_StartSound(player.mo, sfx_adderr, player)
							end
						else //Not enough!
							S_StartSound(player.mo, sfx_notadd, player)
						end
					end
				//Get the angle before going into the menu
				else
					player.mo.skipcrouchdir = player.drawangle
					if player.jumptapping and not player.exiting
					and not G_IsSpecialStage()
						S_StartSound(player.mo, sfx_cdfm23, player)
						player.mo.skipselection = 0
						player.mo.skipgold = false
						player.mo.skipmenu = true
					end
				end
			end
		//Start a crouch
		elseif player.cmd.buttons & BT_USE and P_IsObjectOnGround(player.mo)
		and P_GetPlayerControlDirection(player) == 0
		and not (player.pflags & PF_SPINNING)
		and not (player.mo.eflags & MFE_JUSTHITFLOOR)
		and not (player.pflags & PF_JUMPED)
		and not (player.hugging)
			player.mo.state = S_PLAY_SKIPCROUCH
			player.mo.skipcrouching = true
		end
		
		//Bonkin'!
		if player.mo.skipdivehit
			if P_IsObjectOnGround(player.mo)
				player.mo.skipdivehit = false
				player.mo.state = S_PLAY_STND
			else
				player.pflags = $ | PF_FULLSTASIS
				player.mo.state = S_PLAY_SKIPBONK
				if leveltime % 2 == 0
					P_SetObjectMomZ(player.mo, -FRACUNIT, true)
				end
			end
		
		//Slidin'!
		elseif player.mo.state == S_PLAY_SKIPSLIDE
			player.pflags = $|PF_SPINNING
			
			if P_IsObjectOnGround(player.mo)
				if not (leveltime % 5)
					S_StartSound(player.mo, sfx_s3k7e)
					//P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPINDUST)
				end
				
				//Make the slide usable for rising Spindashable platforms
				local sectorthing = P_PlayerTouchingSectorSpecial(player, 0, 0)
				if sectorthing.valid then
					for fof in sectorthing.ffloors()
						if fof.valid and (abs(fof.topheight - player.mo.z) <= 40*player.mo.scale
						or abs(fof.bottomheight - player.mo.z+player.mo.height) <= 40*player.mo.scale)
						and fof.master and fof.master.valid and fof.master.flags&ML_NOCLIMB
						and (fof.master.special == 153 or fof.master.special == 180
						or (fof.master.special >= 150 and fof.master.special <= 152)
						or (fof.master.special >= 190 and fof.master.special <= 195)
						or fof.master.special == 176 or fof.master.special == 177)
							player.pflags = $|PF_STARTDASH
							P_InstaThrust(player.mo,0,0)
						end
					end
				end
			else
				player.mo.state = S_PLAY_SPRING
				player.pflags = $&~PF_SPINNING
			end
			
		//Divin'!
		elseif player.mo.skipdove
			if leveltime % 5 == 0
				P_SetObjectMomZ(player.mo, -FRACUNIT, true)
			end
		end
		
		//Smug Dance
		if player.skipsmug
		and not (player.hugging)
			player.panim = PA_DASH
			if not (P_IsObjectOnGround(player.mo) and not player.mo.skipdove
			and player.mo.state != S_PLAY_SKIPSLIDE and not player.mo.skipcrouching)
			or player.skiptosstapping
				if player.mo.state == S_PLAY_SKIPSMUG
					player.mo.state = S_PLAY_STND
				end
				player.skipsmug = false
				P_RestoreMusic(player)
			else
				if player.mo.state != S_PLAY_SKIPSMUG
					player.mo.state = S_PLAY_SKIPSMUG
				end
				player.pflags = $|PF_FULLSTASIS
			end
		elseif P_IsObjectOnGround(player.mo) and not player.mo.skipdove
		and player.mo.state != S_PLAY_SKIPSLIDE and not player.mo.skipcrouching
		and player.skiptosstapping
			player.skipsmug = true
			P_PlayJingleMusic(player, "SMUGDANCE", nil, true, JT_OTHER)
		end
		if player.skipsmug --After 20 seconds, spawn funky color particles
		player.mo.skipsmugtimer = player.mo.skipsmugtimer and $+1 or 1
			local p = player //Laziness again. Large part of this are imported from SMS.
			local s = player.mo
			if (s.skipsmugtimer > 785)
				if (s.skipsmugtimer == 786)
					local ztotal = 0							
					for z in players.iterate
						if z.mo and z.mo.skipsmugtimer and (z.mo.skipsmugtimer > 785)
						ztotal = $+1
						end
					end
					if (ztotal > 3) --Any more than 3 and we'll cause lag if people all dance in the same spot, which is likely.
					s.skipsmugtimer = 1
					else
						if p.mysticsuper
						P_FlashPal(p, PAL_NUKE, 10)
						S_StartSound(s, sfx_bkpoof)
						S_StartSound(s, sfx_rumble)	
						P_NukeEnemies(s, s, 1500*FRACUNIT)
						else
						P_FlashPal(p, PAL_RECYCLE, 10)
						end
					end
				end
				if p.mysticsuper --The Dance...of DESTRUCTION!!
					if (s.frame == 1048580 or s.frame == 1048577)
					and (p.anim_duration == 1 or s.tics == 1)
					P_NukeEnemies(s, s, 1500*FRACUNIT)  --Destroy everything in the rhythm of your dancing
					end
					if p == displayplayer --Let's not bother other players with this.
					P_StartQuake(P_RandomRange(10,60)*FRACUNIT, 1)
					end
				  	for d = 1,2 --Blow shit up. Blow shit up! Blow shit up!!
						if (P_RandomRange(0, 1))
						s.smuggfx = P_SpawnMobj(s.x+((P_RandomRange(FixedMul(-1250, s.scale), FixedMul(1250, s.scale)))*FRACUNIT), s.y+((P_RandomRange(FixedMul(-1250, s.scale), FixedMul(1250, s.scale)))*FRACUNIT), s.z+((P_RandomRange(FixedMul(150, s.scale), FixedMul(-120, s.scale)))*FRACUNIT), MT_BOSSEXPLODE)
						else
						s.smuggfx = P_SpawnMobj(s.x+((P_RandomRange(FixedMul(-1250, s.scale), FixedMul(1250, s.scale)))*FRACUNIT), s.y+((P_RandomRange(FixedMul(-1250, s.scale), FixedMul(1250, s.scale)))*FRACUNIT), s.z+((P_RandomRange(FixedMul(150, s.scale), FixedMul(-120, s.scale)))*FRACUNIT), MT_BOSSEXPLODE)
						end
						if s.smuggfx and s.smuggfx.valid
							s.smuggfx.target = s
							s.smuggfx.flags = $|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOBLOCKMAP
							s.smuggfx.frame = $+P_RandomRange(0,2)
							s.smuggfx.frame = $|FF_FULLBRIGHT
							s.smuggfx.scale = s.scale*10/P_RandomRange(1,10)
							s.smuggfx.scalespeed = $/P_RandomRange(1,12)
							s.smuggfx.destscale = s.scale*20
							s.smuggfx.momz = $+P_RandomRange(0,10)*FRACUNIT
							if not P_RandomRange(0,11)
								if not P_RandomRange(0,1)
								S_StartSound(s.smuggfx, P_RandomRange(sfx_rocks1, sfx_rocks4))
								else
								S_StartSound(s.smuggfx, sfx_brakrx)
								end
							end
						end
				  	end
				else --Smugness-induced hallucinations.
					if (P_RandomRange(0, 1))
					s.smuggfx = P_SpawnMobj(s.x+((P_RandomRange(FixedMul(-750, s.scale), FixedMul(750, s.scale)))*FRACUNIT), s.y+((P_RandomRange(FixedMul(-750, s.scale), FixedMul(750, s.scale)))*FRACUNIT), s.z+((P_RandomRange(FixedMul(150, s.scale), FixedMul(-120, s.scale)))*FRACUNIT), MT_THOK)
					else				
					s.smuggfx = P_SpawnMobj(s.x+((P_RandomRange(FixedMul(-350, s.scale), FixedMul(350, s.scale)))*FRACUNIT), s.y+((P_RandomRange(FixedMul(-350, s.scale), FixedMul(350, s.scale)))*FRACUNIT), s.z+((P_RandomRange(FixedMul(40, s.scale), FixedMul(-120, s.scale)))*FRACUNIT), MT_BOXSPARKLE)
					end
					if s.smuggfx
						s.smuggfx.target = s
						s.smuggfx.flags = $|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOBLOCKMAP
						P_SetObjectMomZ(s.smuggfx, ((P_RandomRange(2, 6))*FRACUNIT))	
						if (s.smuggfx.type == MT_THOK)
							s.smuggfx.frame = $|TR_TRANS40|FF_FULLBRIGHT
							s.smuggfx.color = P_RandomRange(SKINCOLOR_SUPERSILVER1, SKINCOLOR_SUPERTAN5)
							s.smuggfx.scale = s.scale*3/P_RandomRange(1,6)
							s.smuggfx.scalespeed = $/12
							s.smuggfx.destscale = s.scale*2
							s.smuggfx.tics = 100
						else --Box Sparkle
							if P_RandomRange(0,1)
							s.smuggfx.rollangle = FixedAngle(45*FRACUNIT)
							end
							s.smuggfx.fuse = 100			
							s.smuggfx.scale = s.scale*2/P_RandomRange(1,4)
							s.smuggfx.destscale = s.scale*(P_RandomRange(4, 8))
							s.smuggfx.tics = 40
						end
					end
				end
			end
		elseif player.mo.skipsmugtimer
		player.mo.skipsmugtimer = 0
		end
		
	else
		if player.skipflashlight and player.skipflashlight.valid
			P_KillMobj(player.skipflashlight)
		end
		if player.skipsmug
			if player.mo.state == S_PLAY_SKIPSMUG
				player.mo.state = S_PLAY_STND
			end
			player.skipsmug = false
			P_RestoreMusic(player)
		end
		if player.mo and player.mo.valid and player.mo.skin == "fehn"
			R_SetPlayerSkin(player, "skip")
			player.mo.state = S_PLAY_SKIPSMUG
			player.skipsmug = true
			P_PlayJingleMusic(player, "SMUGDANCE", nil, true, JT_OTHER)
		end
	end
end)

//Automatically start sliding if you're about to be crushed
//And monitors thrown by Skip don't crush players
addHook("ShouldDamage", function(target, inflictor, source, damage, damagetype)
	if target and target.valid and target.player
		if inflictor == nil and source == nil and target.skin == "skip"
		and damagetype == DMG_CRUSHED and P_IsObjectOnGround(target)
		and target.ceilingz - target.floorz >= FixedMul(skins[target.skin].spinheight, target.scale)
			target.state = S_PLAY_SKIPSLIDE
			target.player.pflags = $|PF_SPINNING&~PF_JUMPED&~PF_THOKKED
			resetskip(target.player)
			return false
		elseif inflictor and inflictor.valid and inflictor.flags&MF_MONITOR
		and inflictor.skipthrown
			return false
		end
	end
end, MT_PLAYER)

//Make it so that when Skip spawns a monitor, he has a grace-period in which
//the monitor cannot be broken by anyone else but him
local function skipmonitorgrace(mobj)
	if mobj.skipgrace
		mobj.skipgrace = $-1
	end
end
for i = 0, skiptotalcraft
	addHook("MobjThinker", skipmonitorgrace, skipcraftlist[i])
end

//Same here
addHook("ShouldDamage", function(target, inflictor, source, damage, damagetype)
	if target and target.valid and target.flags&MF_MONITOR and target.skipthrown
	and target.skipgrace and target.skipskip and target.skipskip.valid
	and source != target.skipskip
		if source and source.valid and source.player
		and P_MobjFlip(source)*source.momz < 0
			if (source.player.powers[pw_shield] & SH_NOSTACK) == SH_BUBBLEWRAP
			and source.player.pflags&PF_SHIELDABILITY
				P_DoBubbleBounce(source.player)
			else
				S_StartSound(source, sfx_s3k7b)
				if source.player.pflags&PF_SHIELDABILITY
					source.player.pflags = $&~PF_SHIELDABILITY
				end
				source.momz = $*-1
			end
		end
		return false
	end
end)

//Make Skip-created monitors not leave behind their corpses
addHook("MobjDeath", function(target, inflictor, source, damage, damagetype)
	if target and target.valid and target.flags&MF_MONITOR and target.skipthrown
		target.fuse = 1
		target.target = source
		target.state = target.info.deathstate
		return true
	end
end)

//Same here
addHook("MobjFuse", function(target)
	if target and target.valid and target.flags&MF_MONITOR and target.skipthrown
		target.state = S_XPLD1
		return true
	end
end)

//Make Skip's attacks attack
addHook("PlayerCanDamage", function(player, mobj)
	if player.mo and player.mo.valid and player.mo.skin == "skip"
	and player.mo.skipdove
		return true
	end
end)

//Reset your variables when you spawn
//also resets your state, this plays Skip's idle properly when he spawns
addHook("PlayerSpawn", function(player)
	if player.skipscrap == nil
		if gametyperules&GTR_FRIENDLY and not modeattacking
			player.skipscrap = 40
		else
			player.skipscrap = 80
		end
	end
	if player.mo and player.mo.valid and player.mo.skin == "skip"
		resetskip(player)
		player.skipyoffset = 0
		if player.powers[pw_carry] != CR_NIGHTSMODE then player.mo.state = S_PLAY_STND end
		player.skiplighton = false
		if player.skipshield and gametyperules&GTR_FRIENDLY
		and not G_IsSpecialStage()
			P_SwitchShield(player, player.skipshield)
		end
	end
end)

//Reset your scraps to 80 when first going into a competitive gametype level
addHook("MapLoad", function(mapnum)
	if gametyperules&GTR_FRIENDLY and not modeattacking then return end
	for player in players.iterate
		player.skipscrap = 80
	end
end)

//No normal shield abilities! We've got dive modification for that
addHook("ShieldSpecial", function(player)
	if player.mo and player.mo.valid and player.mo.skin == "skip"
		return true
	end
end)

//Kirby Support
if not(kirbyabilitytable)
    rawset(_G, "kirbyabilitytable", {})
end
kirbyabilitytable["skip"] = 7